// [I] 186 real inverted arrow signal plus K line color Stopreversal Mt4
#property indicator_chart_window 
#include <stdlib.mqh> 
#property indicator_buffers 4 
#property indicator_color1 Blue 
#property indicator_width1 1 
#property indicator_color2 Red 
#property indicator_width2 1 
#property indicator_color3 DodgerBlue 
#property indicator_color4 Tomato

extern double nPips = 0.003; 
extern bool usingthealarm = true; 
extern bool usingthemail = true; 
extern int AlertMinutesB4Close = 30;

double blueuparrow []; 
double reddownarrow []; 
double bluecolumngroup [], andalusitegroup [];

// ------------------------------

int init () 
  { 
   SetIndexStyle (0, DRAW_ARROW, STYLE_SOLID); 
   SetIndexArrow (0, 233); 
   SetIndexBuffer (0, blueuparrow); 
   SetIndexStyle (1, DRAW_ARROW, STYLE_SOLID); 
   SetIndexArrow (1, 234); 
   SetIndexBuffer (1, reddownarrow);    SetIndexStyle (2, DRAW_HISTOGRAM, 0, 2);    SetIndexBuffer (2, bluecolumngroup);    SetIndexStyle (3, DRAW_HISTOGRAM, 0, 2);    SetIndexBuffer (3, andalusitegroup);
   




   return (0); 
  }

// ------------------------------

int start () 
  { 
   int i = 0; 
   double cnt = 0; 
   double inversionprice = 0; 
   double finallyreversingprice = 0;

   // - Current loop from first Bar to Bar (with i = 0) 
   for (i = Bars-2; i>=0; i--) { 
      if (Close [i] == finallyreversingprice) 
         inversionprice = finallyreversingprice; 
      else { 
         if (Close [i +1] <finallyreversingprice && Close [i] <finallyreversingprice) 
            inversionprice = MathMin (finallyreversingprice, Close [i] * ( 1 + nPips)); 
         else { 
            if (Close [i +1]> finallyreversingprice && Close [i]> finallyreversingprice) 
               inversionprice = MathMax (finallyreversingprice, Close [i] * (1 -nPips)); 
            else { 
               if (Close [i]> finallyreversingprice)                  
                  inversionprice = Close [i] * (1-nPips); 
               else 
                  inversionprice = Close [i] * (1 + nPips); 
              } 
           } 
        }

      if (Close [i]> inversionprice && Close [i +1] <finallyreversingprice && finallyreversingprice!=0) { 
         if (TimeCurrent ()-iTime (NULL, 0, 1) == (iTime (NULL, 0, 1)-iTime (NULL, 0, 2)-AlertMinutesB4Close * 60) 
            && TimeCurrent ()-iTime (NULL, 0, 1)>= (iTime (NULL, 0, 2)-iTime (NULL, 0, 3)-AlertMinutesB4Close * 60) 
            && TimeCurrent ()-iTime (NULL, 0, 2)>= (iTime (NULL, 0, 1)-iTime (NULL, 0, 3)-AlertMinutesB4Close * 60)) { 
            if (usingthealarm == true) 
               Alert ("Look for Buying Opportunity soon"); 
            if (usingthemail == true) 
               SendMail ("Possible Buy Setup on" + Symbol (), "Stop Anticipating Reversal Indicator is on a Buy Setup" + Symbol () + Period () + "in" + AlertMinutesB4Close + "minutes"); 
           } 
         andalusitegroup[i] = Low [i]; 
         bluecolumngroup[i] = High [i]; 
         // setOrder (OP_BUY, 1, Ask, 2, 0, Ask + TakeProfit * Point, Blue); 
         //Alert ("buy"); 
         blueuparrow[i] = inversionprice; 
        }


      if (Close [i] <inversionprice && Close [i +1]> finallyreversingprice && finallyreversingprice!=0) { 
         if ((TimeCurrent ()-iTime (NULL, 0, 1)) == (iTime (NULL, 0, 1)-iTime (NULL, 0, 2)-AlertMinutesB4Close * 60) 
            && (TimeCurrent ()-iTime (NULL, 0, 1))>= (iTime (NULL, 0, 2) - iTime (NULL, 0, 3)-AlertMinutesB4Close * 60) 
            && (TimeCurrent ()-iTime (NULL, 0, 2))>= (iTime (NULL, 0, 1)-iTime (NULL, 0, 3)-AlertMinutesB4Close * 60)) { 
            if (usingthealarm == true) 
               Alert ("Look for Selling Opportunity soon"); 
            if (usingthemail == true) 
               SendMail ("Possible Sell Setup on" + Symbol (), "Stop Reversal Indicator is Anticipating a Sellz Setup on "+ Symbol () + Period () +" in "+ AlertMinutesB4Close +" minutes "); 
           } 
         bluecolumngroup[i] = Low [i]; 
         andalusitegroup[i] = High [i]; 
         // SetOrder (OP_SELL, 1, bid, 2, 0, bid-TakeProfit * Point, Red); 
         reddownarrow [i] = inversionprice; 
         //Alert ("Sell"); 
        }       finallyreversingprice = inversionprice;       // Alert(inversionprice);      
        } 
        return(0);   
        }
        // ------------------------------